//
// Left Leaning Red Black tree with relative node keys, i.e. the key in each node
// is relative to its immediate neighbors.
//
// When using this code please cite:
//
// M. Holenderski, R.J. Bril and J.J. Lukkien, "Red-black trees with relative node keys",
// Information Processing Letters, vol. 114, issue 11, November 2014.
//
// Copyright 2013 Mike Holenderski, mike@holenderski.com
//

#include <stdlib.h>
#include <stdio.h>

typedef int (*LLRB_COMPARISON)(int, int);
typedef struct llrb_s {
  struct llrb_node_s *root;
  int cumulative;
  LLRB_COMPARISON comparison;
  FILE* file;
} LLRBTree;

void init(LLRBTree *tree, LLRB_COMPARISON comparison);
int max_depth(LLRBTree *tree);

void printTree(FILE* f, LLRBTree *tree);
void insert(LLRBTree *tree, int time);
void delete(LLRBTree* tree, int time);